<?php // $Id$

class block_cmsnavigation extends block_base {
    function init() {
        $this->title = get_string('cmsnavigation','cms');
        $this->content_type = BLOCK_TYPE_TEXT;
        $this->version = 2005020301;
    }

    function specialization() {
        // We allow empty titles
        $this->title = isset($this->config->title) ? $this->config->title : '';
    }

    function instance_allow_multiple() {
        return true;
    }

    function is_login_required ( $menuid ) {
        return get_field("cmsnavi", "requirelogin", "id", $menuid);
    }

    function is_guest_allowed ( $menuid ) {
        return get_field("cmsnavi", "allowguest", "id", $menuid);
    }

    function construct_tree_menu ($parentid, $path, $menuid, $courseid, &$navidata) {

        global $CFG, $USER, $SITE;
        static $top;

        if ( empty($top) ) {
            $top = array();
        }

        if (! empty($navidata) ) {

            $keys = array_keys($navidata);
            $cnt  = count($keys);

            $this->content->text .= '<ul class="cms-navi-list">' . "\n";
            //foreach ($navidata as $navi) {
            for ( $i = 0; $i < $cnt; $i++ ) {
                $navi = &$navidata[$keys[$i]];

                if ( $navi->parentid == $parentid ) {
                    array_push($top, $navi->pageid);

                    if ( ($navi->pageid == end($path)) or ( empty($path) && $navi->isfp) ) {
                        $class = 'class="cms-active-1"';
                    } else if ( in_array($navi->pageid, $path) ) {
                        $class = 'class="cms-active-2"';
                    } else {
                        $class = 'class="cms-inactive"';
                    }

                    $baseurl = ($courseid > intval($SITE->id) ) ? "$CFG->wwwroot/course/view.php?id=$courseid&amp;pid=" :
                                                              "$CFG->wwwroot/?pid=";

                    $this->content->text .= '<li '. $class .'><a '. $class .' href="'.
                                        $baseurl . implode(",", $top) .
                                        '">' . stripslashes($navi->title) .
                                        '</a>' . "\n";
                    if ( in_array($navi->pageid, $path) or (empty($path) && $navi->isfp) ) {
                        $this->construct_tree_menu($navi->pageid, $path, $menuid, $courseid, $navidata);
                    }

                    $this->content->text .= '</li>' . "\n";

                    array_pop($top);

                }
            }
            $this->content->text .= '</ul>' . "\n";
        }

    }

    function get_content() {

        global $CFG, $USER;

        $get  = !empty($_GET['pid']) ? explode(",", $_GET['pid']) : 0;
        $path = array();
        if (! empty($get) ) {
            foreach ($get as $key => $value) {
                $value = intval($value);
                $path[$value] = $value;
            }
        }

        $courseid = optional_param('id', 1, PARAM_INT);
        $menuid = !empty($this->config->menu) ? intval($this->config->menu) : 0;

        if ($this->content !== NULL) {
            return $this->content;
        }

        $this->content = new stdClass;
        $this->content->text = '';

        $menurequirelogin = $this->is_login_required($menuid);
        $menuallowguest   = $this->is_guest_allowed($menuid);

        if (($menurequirelogin && empty($USER->loggedin)) or
            ($menurequirelogin && isguest() && !$menuallowguest)) {
              return $this->content;
        }

        if ($this->edit_controls !== NULL) {

            $stradmin = get_string('admin');
            // TODO: Replace style definition to class
            // and put it in css file.
            $this->content->footer  = '<a style="font-size: x-small;" href="';
            $this->content->footer .= $CFG->wwwroot .'/cms/index.php?course='. $courseid .'&amp;sesskey=';
            $this->content->footer .= $USER->sesskey .'">'. $stradmin .'...</a>';

        } else {

            $this->content->footer = '';

        }

        if ( $CFG->frontpage != FRONTPAGECMS ) {
            return $this->content;
        }

        $navidata = get_records_sql("SELECT n.pageid, n.parentid, n.title, n.isfp, p.publish, cn.requirelogin
                                     FROM {$CFG->prefix}cmsnavi_data AS n,
                                          {$CFG->prefix}cmspages AS p,
                                          {$CFG->prefix}cmsnavi AS cn
                                     WHERE n.pageid = p.id AND p.publish = 1
                                     AND n.naviid = $menuid
                                     AND (cn.id = $menuid AND cn.course = $courseid)
                                     ORDER BY sortorder");

        $this->content->text .= "\n" . '<div class="cms-navi">' . "\n";
        $this->construct_tree_menu(0, $path, $menuid, $courseid, $navidata);
        $this->content->text .= '</div>' . "\n";

        return $this->content;

    }
}

?>