<?php // $Id$
// local library for CMS like features...
// $Revision$
// $Author$
// $Date$
//

require_once('cmslib.php');

function cms_print_menus ($courseid=1) {

    cms_print_newmenulink($courseid);
    cms_print_allmenus($courseid);

}

function cms_print_allmenus ($courseid=1) {

    global $CFG, $USER;

    $menus = get_records("cmsnavi", "course", $courseid);
    $pixpath  = "$CFG->wwwroot/cms/pix";

    if (is_array($menus)) {
        include_once('html/printmenus.php');
    } else {
        echo "<div align=\"center\">";
        echo "<p>";
        print_string("nomenus","cms");
        echo "</p></div>";
    }

}

function cms_print_newmenulink ($courseid=1) {

    global $USER;
    $straddnew = get_string('addnewmenu','cms');

    echo "<div align=\"center\"><p><a href=\"menuadd.php?course=$courseid&amp;";
    echo "sesskey=$USER->sesskey\">$straddnew</a></p></div>\n";

}

function cms_print_pages ($menuid=1, $courseid=1) {

    global $CFG, $USER;

    $menuid = clean_param($menuid, PARAM_INT);
    $menus  = get_records("cmsnavi", "course", $courseid);

    $menuids = array();

    foreach ($menus as $menu) {
        $menuids[] = (int) $menu->id;
    }

    if ( !in_array($menuid, $menuids) ) {
        $menuid = $menuids[0];
    }

    include_once('html/navimenu.php');
    include_once('html/pagesindex.php');

}

function cms_print_addnewpage ($menuid, $courseid=1) {

    global $USER;

    $menuid = clean_param($menuid, PARAM_INT);

    echo "<p><a href=\"pageadd.php?id=$menuid&amp;sesskey=$USER->sesskey&amp;course=$courseid\">";
    print_string("addnewpage","cms");
    echo "</a></p>\n";

}

function cms_get_navi ($parentid, $menuid=1) {

    global $CFG;

    $menuid   = intval($menuid);
    $parentid = intval($parentid);

    $sql  = "SELECT n.pageid, n.title, n.isfp, p.publish, ";
    $sql .= "cn.requirelogin FROM {$CFG->prefix}cmsnavi_data AS n, ";
    $sql .= "{$CFG->prefix}cmspages AS p, ";
    $sql .= "{$CFG->prefix}cmsnavi AS cn ";
    $sql .= "WHERE n.pageid = p.id AND p.publish = 1 ";
    $sql .= "AND n.naviid= $menuid ";
    $sql .= "AND cn.id = $menuid ";
    $sql .= "AND n.parentid = $parentid";

    return get_records_sql($sql);

}

function cms_get_pagedata ($pageid) {

    global $CFG;

    $pageid = clean_param($pageid, PARAM_INT);

    $sql  = "SELECT p.*, n.title, n.id AS nid, n.naviid, n.parentid ";
    $sql .= "FROM {$CFG->prefix}cmspages AS p, ";
    $sql .= "{$CFG->prefix}cmsnavi_data AS n ";
    $sql .= "WHERE n.pageid = p.id AND n.pageid = ". $pageid ."";

    return get_record_sql($sql);

}

function cms_reset_menu_order ($parentid, $menuid) {

    global $CFG;
    static $count;

    $parentid = intval($parentid);
    $menuid   = intval($menuid);

    if ( empty($count) ) {
        $count = 0;
    }

    $pages = get_records_sql("SELECT id, pageid, parentid
                              FROM {$CFG->prefix}cmsnavi_data
                              WHERE parentid = $parentid
                              AND naviid = $menuid");

    if (! empty($pages) ) {
        $count++;
        $pagecount = 1;
        foreach ($pages as $page) {

            $sortorder = (1000 * $count) + $pagecount;
            set_field("cmsnavi_data", "sortorder", $sortorder, "pageid", intval($page->pageid));

            cms_reset_menu_order($page->pageid, $menuid);
            $pagecount++;

        }
        $count--;
    }

    return true;

}

class cms_pages_menu {

    var $pages;
    var $menuid;
    var $courseid;
    var $imgup;
    var $imgdown;
    var $imgright;
    var $imgleft;
    var $imgpub;
    var $imgunpub;
    var $imgblank;
    var $strisdefault;
    var $strsetasdefault;
    var $strpublished;
    var $strunpublished;

    function cms_pages_menu ( $menuid, $courseid=1 ) {

        global $CFG;

        $this->menuid = clean_param($menuid, PARAM_INT);
        $this->courseid = clean_param($courseid, PARAM_INT);
        // Get strings
        $this->strisdefault    = get_string('isdefaultpage', 'cms');
        $this->strsetasdefault = get_string('setdefault'   , 'cms');
        $this->strpublished    = get_string('published'    , 'cms');
        $this->strunpublished  = get_string('unpublished'  , 'cms');
        // Cache images. Pointless to initialize them in
        // methods every time.
        $pixpath = $CFG->wwwroot .'/cms/pix';
        $this->imgup   = '<img src="'. $pixpath .'/up.gif" width="11" height="11" alt="" border="0" />';
        $this->imgdown = '<img src="'. $pixpath .'/down.gif" width="11" height="11" alt="" border="0" />';
        $this->imgright = '<img src="'. $pixpath .'/right.gif" width="11" height="11" alt="" border="0" />';
        $this->imgleft  = '<img src="'. $pixpath .'/left.gif" width="11" height="11" alt="" border="0" />';
        $this->imgpub  = '<img src="'. $pixpath .'/yespublish.gif" alt="' .
                         stripslashes($this->strpublished) .'" title="' .
                         stripslashes($this->strpublished) .'" />';
        $this->imgunpub = '<img src="'. $pixpath .'/nopublish.gif" alt="' .
                          stripslashes($this->strunpublished) .'" title="' .
                          stripslashes($this->strunpublished) .'" />';
        $this->imgblank = '<img src="'. $pixpath .'/blank.gif" width="11" height="11" alt="" />';

        $sql  = "SELECT n.*,p.publish, p.created, p.modified ";
        $sql .= "FROM {$CFG->prefix}cmsnavi_data AS n, {$CFG->prefix}cmspages AS p ";
        $sql .= "WHERE n.pageid = p.id AND ";
        $sql .= " n.naviid = ". $this->menuid ." ";
        $sql .= "ORDER BY sortorder";

        /*$this->pages = get_records_sql("SELECT cd.id, cd.pageid, cd.parentid, cd.title FROM
                                            {$CFG->prefix}cmsnavi_data AS cd
                                       INNER JOIN
                                            {$CFG->prefix}cmsnavi AS cn
                                       ON cd.naviid = cn.id
                                       WHERE cn.id = $menuid
                                       AND cn.course = $courseid
                                       ORDER BY sortorder");*/
        $this->pages = get_records_sql($sql);

    }

    function __construct ( $menuid, $currentpage=0, $currentparent=0  ) {
        $this->cms_pages_menu($menuid, $currentpage);
    }

    function __hasParent ( $pageid, $returnid=FALSE) {

        $pageid = intval($pageid);

        foreach ( $this->pages as $page ) {
            if ( $pageid === intval($page->pageid) ) {
                if ( $page->parentid != 0 ) {
                    return ($returnid) ? intval($page->parentid) : true;
                }
                return false;
            }
        }
        return false;
    }

    function __hasChildren ( $pageid, $returnid=FALSE ) {

        $pageid = intval($pageid);

        foreach ( $this->pages as $page ) {
            if ( $pageid === intval($page->parentid) ) {
                return ($returnid) ? intval($page->pageid) : true;
            }
        }

        return false;

    }

    function __hasSibling ( $pageid ) {

        $pageid = intval($pageid);
        $myparent = false;
        foreach ( $this->pages as $page ) {
            if ( intval($page->pageid) === $pageid ) {
                $myparent = intval($page->parentid);
            }
        }

        if ( $myparent !== false ) {
            foreach ( $this->pages as $page ) {
                if ( (intval($page->pageid) !== $pageid) &&
                     $myparent === intval($page->parentid) ) {
                    return true;
                }
            }
        }

        return false;

    }

    function __firstAtLevel ( $pageid ) {

        $pageid = intval($pageid);
        $myparent = false;
        $thislevel = array();

        foreach ( $this->pages as $p ) {
            if ( intval($p->pageid) === $pageid ) {
                $myparent = intval($p->parentid);
            }
        }

        if ( $myparent !== false ) {
            foreach ( $this->pages as $p ) {
                if ( $myparent === intval($p->parentid) ) {
                    array_push($thislevel, $p->pageid);
                }
            }

            $cnt = 0;

            foreach ( $thislevel as $value ) {
                if ( $pageid === intval($value) ) {
                    if ( $cnt === 0 ) {
                        return true;
                    }
                }
                $cnt++;
            }

        }

        return false;

    }

    function __lastAtLevel ( $pageid ) {

        $pageid = intval($pageid);
        $myparent = false;
        $thislevel = array();

        foreach ( $this->pages as $p ) {
            if ( intval($p->pageid) === $pageid ) {
                $myparent = intval($p->parentid);
            }
        }

        if ( $myparent !== false ) {
            foreach ( $this->pages as $p ) {
                if ( $myparent === intval($p->parentid) ) {
                    array_push($thislevel, $p->pageid);
                }
            }

            $cnt = 0;
            $max = intval(count($thislevel));

            foreach ( $thislevel as $value ) {
                $cnt++;
                if ( $pageid === intval($value) ) {
                    if ( $cnt === $max ) {
                        return true;
                    }
                }
            }
        }

        return false;

    }

    function get_page_tree_rows ( $parentid ) {

        global $USER;
        static $output, $count, $prevpage;

        if ( empty($output) ) {
            $output = array();
        }
        if ( empty($count) ) {
            $count = 0;
        }

        if ( !empty($this->pages) ) {

            $count++;
            foreach ( $this->pages as $p ) {
                if ( $p->parentid == $parentid ) {
                    $row = array();

                    $row[] = '<input type="checkbox" name="id" value="'.
                         $p->pageid .'" />';

                    $hrefup = '<a href="pages.php?sesskey='. $USER->sesskey .
                          '&sort=up&menuid='. $p->naviid . '&pid='. $p->pageid .
                          '&mid='. $p->parentid .'&course='. $this->courseid .'">'.
                          $this->imgup .'</a>';

                    $hrefdown = '<a href="pages.php?sesskey='. $USER->sesskey .
                            '&sort=down&menuid='. $p->naviid .'&pid='. $p->pageid .
                            '&mid='. $p->parentid .'&course='. $this->courseid .'">'.
                            $this->imgdown .'</a>';


                    if ( !empty($prevpage->pageid) ) {
                        $moveto = $this->__hasParent($p->parentid, true);
                        if ( empty($moveto) ) {
                            $moveto = '0';
                        }
                        $hrefleft = '<a href="pages.php?sesskey='. $USER->sesskey .
                                    '&move='. $moveto .'&amp;pid='. $p->pageid .
                                    '&amp;menuid='. $p->naviid .'&amp;course='.
                                    $this->courseid .'" alt="">'. $this->imgleft .'</a>';
                    }

                    $hrefright = '';
                    if ( !empty($prevpage->pageid) ) {
                        $hrefright  = '<a href="pages.php?sesskey='. $USER->sesskey .
                                      '&move='. $prevpage->pageid .'&amp;pid='. $p->pageid .
                                      '&amp;menuid='. $p->naviid .'&amp;course='.
                                      $this->courseid .'" alt="">'. $this->imgright .'</a>';
                    }

                    $moverow = '<table border="0" cellpadding="2"><tr>';
                    //$row[] = "$hrefup<br />$hrefdown";
                    if ( $this->__firstAtLevel($p->pageid) &&
                         $this->__hasSibling($p->pageid) ) {
                        $moverow .= '<td>'. $hrefdown .'</td><td>'. $this->imgblank .'</td>';
                        //$row[] = $hrefdown;
                        //$row[] = "&nbsp;";
                    } else if ( $this->__lastAtLevel($p->pageid) &&
                                $this->__hasSibling($p->pageid) ) {
                        //$row[] = "&nbsp;";
                        //$row[] = $this->imgblank .''. $hrefup;
                        $moverow .= '<td>'. $this->imgblank .'</td><td>'. $hrefup .'</td>';
                    } else if ( $this->__hasSibling($p->pageid) ) {
                        $moverow .= '<td>'.$hrefdown .'</td><td>'. $hrefup .'</td>';
                        //$row[] = $hrefdown .''. $hrefup;
                    } else {
                        $moverow .= '<td>'.$this->imgblank .'</td><td>'. $this->imgblank .'</td>';
                        //$row[] = "&nbsp;";
                    }

                    // Add level changers.
                    if ( $this->__hasParent($p->pageid) ) {
                        $moverow .= '<td>'. $hrefleft .'</td>';
                    } else {
                        $moverow .= '<td>'. $this->imgblank .'</td>';
                    }
                    if ( $this->__hasSibling($p->pageid) && !$this->__firstAtLevel($p->pageid) ) {
                        $moverow .= '<td>'. $hrefright .'</td>';
                    }

                    $row[] = $moverow .'</tr></table>';

                    $pagetitle  = str_repeat("&nbsp;&nbsp;&nbsp;&nbsp;", $count - 1);
                    $pagetitle .= !empty($p->isfp) ?
                                  '<strong>' . stripslashes($p->title) .'</strong>' :
                                  stripslashes($p->title);
                    $row[] = $pagetitle;

                    $default = !empty($p->isfp) ? stripslashes($this->strisdefault) :
                               ((!empty($p->publish) && empty($p->parentid)) ?
                               '<a href="pages.php?course='. $this->courseid .'&amp;sesskey='. $USER->sesskey .
                               '&setfp='. $p->id .'">'. stripslashes($this->strsetasdefault) .'</a>' : '');
                    $row[] = $default;

                    $publishurl = '<a href="pages.php?sesskey='. $USER->sesskey .
                                  '&amp;pid='. $p->pageid .'&amp;menuid='. $p->naviid .
                                  '&amp;course='. $this->courseid;
                    $publish = !empty($p->publish) ? $publishurl .'&amp;publish=no">'. $this->imgpub .'</a>'
                                                   : $publishurl .'&amp;publish=yes">'. $this->imgunpub .'</a>';
                    $row[] = $publish;

                    //$row[] = userdate($p->created, "%x %X");
                    $row[] = userdate($p->modified, "%x %X");

                    array_push($output, $row);
                    $this->get_page_tree_rows ($p->pageid);
                    $prevpage = $p;
                }
            }
            $count--;
        }

        return $output;
    }

}

function cms_get_children_ids ( $parentid ) {

    static $childrenids;

    $parentid = intval($parentid);

    if ( empty($childrenids) ) {
        $childrenids = array();
    }

    if ( $children = get_records("cmsnavi_data", "parentid", $parentid) ) {
        foreach ( $children as $child ) {
            array_push($childrenids, intval($child->pageid));
            cms_get_children_ids($child->pageid);
        }
    }

    return $childrenids;

}
?>