<?PHP  //$Id$

function cms_upgrade($oldversion=0) {

    global $CFG, $db;

    $result = true;

    if ($oldversion < 2005061600 && $result) {

        $sql =  "CREATE TABLE {$CFG->prefix}cms (";
        $sql .= " id int(10) unsigned NOT NULL AUTO_INCREMENT,";
        $sql .= " name varchar(100) NOT NULL,";
        $sql .= " value varchar(255),";
        $sql .= " PRIMARY KEY(id),";
        $sql .= " UNIQUE KEY {$CFG->prefix}cms_name (name)";
        $sql .= ")";

        execute_sql($sql);

        $sql = "INSERT INTO {$CFG->prefix}cms VALUES(NULL, 'version','2005061600')";

        execute_sql($sql);

        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN requirelogin TINYINT(1) ";
        $sql .= "NOT NULL DEFAULT '0'";

        execute_sql($sql);

    }

    if ($oldversion < 2005073001 && $result) {

        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi_data ADD COLUMN parentid ";
        $sql .= "int (10) unsigned NOT NULL default '0'";

        execute_sql($sql);

        $sql = "ALTER TABLE {$CFG->prefix}cmsnavi_data ADD INDEX navi_parent_idx (parentid)";

        execute_sql($sql);

    }

    if ($oldversion < 2005073101 && $result) {

        include('cmslocallib.php');

        $menus = get_records("cmsnavi");

        if (! empty($menus) ) {
            foreach ($menus as $menu) {
                cms_reset_menu_order(0, $menu->id);
            }
        }

        $result = true;

    }

    if ( $oldversion < 2005092301 && $result ) {

        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN course INT(10) ";
        $sql .= "UNSIGNED DEFAULT '1' NOT NULL AFTER id";

        execute_sql($sql);

        $sql = "ALTER TABLE {$CFG->prefix}cmsnavi ADD INDEX {$CFG->prefix}cmsnavi_idx (course)";
        execute_sql($sql);

        $result = true;

    }

    if ( $oldversion < 2005111401 && $result ) {

        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN allowguest TINYINT(1) ";
        $sql .= "UNSIGNED DEFAULT '0' NOT NULL";

        execute_sql($sql);

        $result = true;

    }

    if ( $oldversion < 2005112001 && $result ) {
        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN printdate TINYINT(1) ";
        $sql .= "UNSIGNED DEFAULT '1' NOT NULL";

        execute_sql($sql);

        $result = true;
    }

    if ( $oldversion < 2006040100 && $result ) {

        $cmstables = array("cms","cmsnavi","cmsnavi_data","cmspages");
        $missing = array();

        $cmscols = array("cms" => array("id","name","value"),
                         "cmsnavi" => array("id","course","name","intro","created",
                                            "modified","requirelogin","allowguest",
                                            "printdate"),
                         "cmsnavi_data" => array("id","naviid","pageid","title","isfp",
                                                 "sortorder","parentid"),
                         "cmspages" => array("id","body","created","modified","publish"));

        foreach ( $cmstables as $table ) {
            $metacols = $db->MetaColumnNames($CFG->prefix.$table);

            foreach ( $cmscols[$table] as $column ) {
                if ( !in_array($column, $metacols) ) {
                    $absent = new stdClass;
                    $absent->tablename = $table;
                    $absent->column = $column;
                    array_push($missing, $absent);
                }
            }
        }

        print_r($missing);

        if ( !empty($missing) ) {
            foreach ( $missing as $absent ) {
                // If prefix_cms
                if ( $absent->tablename == 'cms' ) {
                    if ( $absent->column == 'name' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cms ADD COLUMN ";
                        $sql .= "name VARCHAR(100) NOT NULL default 'noname'";
                        execute_sql($sql,false);
                        $sql  = "ALTER TABLE {$CFG->prefix}cms ADD UNIQUE INDEX ";
                        $sql .= "{$CFG->prefix}cms_idx (name)";
                        execute_sql($sql,false);
                    }

                    if ( $absent->column == 'value' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cms ADD COLUMN ";
                        $sql .= "value VARCHAR(255)";
                        execute_sql($sql,false);
                    }
                }

                // If prefix_cmsnavi
                if ( $absent->tablename == 'cmsnavi' ) {
                    if ( $absent->column == 'requirelogin' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN requirelogin TINYINT(1) ";
                        $sql .= "NOT NULL DEFAULT '0'";
                        execute_sql($sql,false);
                    }
                    if ( $absent->column == 'allowguest' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN allowguest TINYINT(1) ";
                        $sql .= "UNSIGNED DEFAULT '0' NOT NULL";
                        execute_sql($sql,false);
                    }
                    if ( $absent->column == 'course' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN course INT(10) ";
                        $sql .= "unsigned NOT NULL default '1' AFTER id";
                        execute_sql($sql);
                        $sql = "ALTER TABLE {$CFG->prefix}cmsnavi ADD INDEX {$CFG->prefix}cmsnavi_idx (course)";
                        execute_sql($sql,false);
                    }
                    if ( $absent->column == 'printdate' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN printdate TINYINT(1) ";
                        $sql .= "UNSIGNED DEFAULT '1' NOT NULL";
                        execute_sql($sql,false);
                    }
                }

                // If prefix_cmsnavi_data
                if ( $absent->tablename = 'cmsnavi_data' ) {
                    if ( $absent->column = 'parentid' ) {
                        $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi_data ADD COLUMN parentid ";
                        $sql .= "int (10) unsigned NOT NULL default '0'";
                        execute_sql($sql,false);
                        $sql = "ALTER TABLE {$CFG->prefix}cmsnavi_data ADD INDEX navi_parent_idx (parentid)";
                        execute_sql($sql,false);
                    }
                }
            }
        }
        $result = true;
    }

    //Finally, return result
    return $result;

}
