<?php // $Id$ CMS admin index

/// Check that config.php exists, if not then call the install script
    if (!file_exists("../config.php")) {
        header('Location: ../install.php');
        die;
    }

    require_once("../config.php");

    /// Check if Moodle is properly installed.
    if (! $site = get_site()) {
        redirect("site.php");
    }

    /// Set up the admin user
    if (! record_exists("user_admins")) {   // No admin user yet
        redirect("user.php");
    }

    /// Check for valid admin user
    require_login();

    if ( !isadmin() && !isteacherinanycourse($USER->id, true) ) {
        error("You need to be an admin or a teacher in some course to use this page.",
              "$CFG->wwwroot/");
    }

    if (! confirm_sesskey($USER->sesskey)) {
        error("Session key error! You need to login first!");
    }

    $courseid = optional_param('course', 0, PARAM_INT);

    if ( empty($courseid) ) {
        $courseid = $site->id;
    }

    $course = get_record("course", "id", $courseid);

    $stradministration = get_string("administration");
    $strcms            = get_string('cms','cms');

    // Check if tables exists

    if (! $tables = $db->Metatables()) {
        header('Location: ../index.php');
    } else {

        $cmstables = true;
        $cmstbls   = array("cmsnavi", "cmsnavi_data","cmspages");

        foreach ($cmstbls as $cmstbl) {
            if (! in_array($CFG->prefix . $cmstbl, $tables)) {
                $cmstables = false;
            }
        }

        if (! $cmstables ) {
            $strdatabasesuccess  = get_string("databasesuccess");

            if (file_exists($CFG->dirroot .'/cms/db/'. $CFG->dbtype .'.sql')) {
                $db->debug = true;

                if (modify_database("$CFG->dirroot/cms/db/$CFG->dbtype.sql")) {

                    $db->debug = false;
                    notify($strdatabasesuccess, "green");

                } else {

                    $db->debug = false;
                    error("Error: Main databases NOT set up successfully");

                }

            }

            redirect("$CFG->wwwroot/admin/", $strdatabasesuccess, 1);
            exit;

        }

        // Get cms version
        include_once($CFG->dirroot .'/cms/version.php');
        $dbversion = @get_field("cms", "value", "name", "version");
        $dbversion = (int) $dbversion;

        if ( empty($dbversion) or ( $dbversion < $cmsversion) ) {
            include_once($CFG->dirroot .'/cms/db/'. $CFG->dbtype .'.php');

            print_header("$site->shortname: $stradministration","$site->fullname", " $strcms");

            if ( cms_upgrade($dbversion) ) {
                set_field("cms", "value", $cmsversion, "name", "version");
                notify(get_string('databaseupdated','cms', $cmsversion), 'green');
            }

            print_continue("index.php?course=$courseid&amp;sesskey=$USER->sesskey");
            print_footer();
            exit;

        }

    }

    $metacolumns = $db->MetaColumnNames($CFG->prefix.'cmsnavi');

    if ( !in_array("requirelogin", $metacolumns) ) {

        if ( $CFG->dbtype == 'mysql') {
            $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN requirelogin TINYINT(1) ";
            $sql .= "NOT NULL DEFAULT '0'";

            execute_sql($sql, false);
        }

        if ( $CFG->dbtype == 'postgres7' ) {
            $sql  = "ALTER TABLE {$CFG->prefix}cmsnavi ADD COLUMN requirelogin CHAR(1)";
            execute_sql($sql, false);

            $sql = "ALTER TABLE {$CFG->prefix}cmsnavi ALTER COLUMN requirelogin SET DEFAULT '0'";
            execute_sql($sql, false);

            $sql = "UPDATE TABLE {$CFG->prefix}cmsnavi SET requirelogin = '0' WHERE requirelogin IS NULL";
            execute_sql($sql, false);

           $sql = "ALTER TABLE {$CFG->prefix}cmsnavi ALTER COLUMN requirelogin SET NOT NULL";
            execute_sql($sql, false);
            $return = false;
        }

    }

    if (! file_exists($CFG->dirroot .'/blocks/cmsnavigation')) {
        error("Required block cmsnavigation is missing!",
              "$CFG->wwwroot/admin/");
    }

    ob_start();

    if ($course->category) {
        $navigation = "<a href=\"../course/view.php?id=$course->id\">$course->shortname</a> ->";
    } else {
        $navigation = '';
    }

    print_header("$site->shortname: $stradministration","$site->fullname", "$navigation $strcms");
    print_simple_box_start("center", "100%", "", 20);
    ?>

    <table class="generaltable" border="0" cellpadding="4" cellspacing="2" align="center">
    <tr>
        <td class="generaltablecell">
        <h3><?php echo $strcms . ' '. $stradministration;
                  helpbutton("cms", get_string("cms"), "cms"); ?> </h3>
        <ul>
            <li><a href="menus.php?course=<?php p($courseid) ?>&amp;sesskey=<?php p($USER->sesskey) ?>"><?php print_string('managemenus','cms'); ?></a></li>
            <li><a href="pages.php?course=<?php p($courseid) ?>&amp;sesskey=<?php p($USER->sesskey) ?>"><?php print_string('managepages','cms'); ?></a></li>
        </ul>
        </td>
    </tr>
    </table>
    <?php

    print_simple_box_end();
    print_footer($course);

    ob_end_flush();

?>