<?php // $Id$ CMS admin index

    require_once("../config.php");
    //include_once("$CFG->dirroot/lib/adminlib.php");  // Contains various admin-only functions
    include_once('cmslocallib.php');

    $id     = optional_param('id',     0, PARAM_INT);
    $menuid = optional_param('menuid', 1, PARAM_INT);    //
    $skey   = required_param('sesskey',   PARAM_ALPHANUM);
    $courseid = optional_param('course', 0, PARAM_INT);

    if (! confirm_sesskey($skey)) {
        error("Session key error!");
    }

    /// Set up the overall site name etc.
    if (! $site = get_site()) {
        redirect("site.php");
    }

    if ( empty($courseid) ) {
        $courseid = $site->id;
    }

    if ( !$course = get_record("course", "id", $courseid) ) {
        error("Invalid course id!!!");
    }

    require_login($course->id);

    $isadmin = isadmin();
    $isteacheredit = isteacheredit($course->id);

    if ( !$isadmin && !$isteacheredit ) {
        error("You need to be an admin user to use this page.", "$CFG->wwwroot/");
    }

    if (! empty($_GET['setfp'])) {

        $setfrontpage = required_param('setfp', PARAM_INT);

        if (! empty($setfrontpage)) {

            $newdefaultpageid = (int) $setfrontpage;

            if ( empty($newdefaultpageid) ) {
                error("Invalid page id");
            }

            if (! $olddefault = get_field_sql("SELECT nd.id FROM
                                               {$CFG->prefix}cmsnavi_data AS nd, {$CFG->prefix}cmsnavi AS n
                                               WHERE nd.naviid = n.id
                                               AND n.course = $course->id
                                               AND nd.isfp = 1")) {

                set_field("cmsnavi_data", "isfp", 1, "id", $newdefaultpageid);

            } else {

                set_field("cmsnavi_data", "isfp", 1, "id", $newdefaultpageid);
                set_field("cmsnavi_data", "isfp", 0, "id", $olddefault);

            }

            $strsuccess = get_string("defaultpagechanged","cms");
            redirect("$CFG->wwwroot/cms/pages.php?course=$course->id&amp;sesskey=$USER->sesskey", $strsuccess, 2);

        }
    } else if (! empty($_GET['add']) ) {

        $parentid = !empty($id) ? $id : 0;
        redirect("$CFG->wwwroot/cms/pageadd.php?id=$menuid&amp;sesskey=$USER->sesskey&amp;parentid=$parentid&amp;course=$course->id");

    } else if (! empty($_GET['edit']) ) {

        $id = required_param('id', PARAM_INT);
        redirect("$CFG->wwwroot/cms/pageupdate.php?id=$id&amp;sesskey=$USER->sesskey&amp;course=$course->id");

    } else if (! empty($_GET['purge']) ) {

        $id = required_param('id', PARAM_INT);
        redirect("$CFG->wwwroot/cms/pagedelete.php?id=$id&amp;sesskey=$USER->sesskey&amp;course=$course->id");

    } else {

        // Sort.
        $sort = optional_param('sort', '', PARAM_ALPHA);
        $publish = optional_param('publish', '', PARAM_ALPHA);
        if ( $sort && ($sort == 'up' or $sort == 'down') ) {

            $pageid    = required_param('pid', PARAM_INT);
            $parentid  = required_param('mid', PARAM_INT);
            $direction = required_param('sort', PARAM_ALPHA);

            if (! cms_reorder($pageid, $parentid, $menuid, $direction) ) {
                $strerr = "Couldn't reorder pages!";
            }

        }

        if ( $publish && ( $publish == 'yes' or $publish == 'no' ) ) {
            $pageid = required_param('pid', PARAM_INT);
            $publish = ($publish != 'no') ? '1' : '0';

            set_field("cmspages", "publish", $publish, "id", $pageid);

        }
        if ( isset($_GET['move']) ) {

            $pageid = required_param('pid', PARAM_INT);
            $move   = optional_param('move', '0', PARAM_INT);
            set_field("cmsnavi_data", "parentid", $move, "pageid", $pageid);

        }
    /// Check if there is any menus builded.

        if (! get_record("cmsnavi", "id", $menuid)) {

            $strnomenusyet = get_string("nomenus","cms");
            redirect("$CFG->wwwroot/cms/menus.php?course=$courseid&amp;sesskey=$USER->sesskey", $strnomenusyet, 2);
        }

        $usehtmleditor = can_use_html_editor();

        $stradministration = get_string("administration");
        $strpages          = get_string("pages","cms");

        if ($course->category) {
            $navigation = "<a href=\"../course/view.php?id=$course->id\">$course->shortname</a> -> ";
        } else {
            $navigation = '';
        }

        $navigation .= '<a href="./index.php?course='. $course->id .'&amp;sesskey='. $USER->sesskey .'">CMS</a> -> ';

        ob_start();

        print_header("$site->shortname: $stradministration","$site->fullname", "$navigation $strpages");
        print_simple_box_start("center", "100%", "", 20);
        if (! empty($strerr) ) {
            notify($strerr);
        } else {
            print_heading($stradministration);
        }

        cms_print_pages($menuid, $course->id);

        print_simple_box_end();
        print_footer($course);

        ob_end_flush();

    }

/////////////////////////// FUNCTIONS NEEDED ONLY BY THIS PAGE ///////////////////////////

// Reorder menu items on same level.
function cms_reorder($id, $parent, $menuid, $direction) {

    global $CFG;

    $sql  = "SELECT id, pageid, parentid ";
    $sql .= "FROM ". $CFG->prefix ."cmsnavi_data ";
    $sql .= "WHERE parentid=". $parent ." AND naviid = ". $menuid ." ";
    $sql .= "ORDER BY sortorder";

    if (! ($results = get_records_sql($sql)) ) {
        return false;
    }

    $records = array();
    $tmp     = array();

    $i = 0;
    foreach ($results as $row) {
        $records[$i]['id'] = intval($row->pageid);
        $records[$i]['sortorder'] = intval($i + 1);
        array_push($tmp, $records[$i]);
        $i++;
    }
    unset($results, $i, $row);

    $rows = intval(count($records));

    for ($i = 0; $i < $rows; $i++) {

        if ( $tmp[$i]['id'] == $id ) {
            // Check direction and can we move up?
            switch (strtolower($direction)) {
                case 'up':
                if ($i != 0) {
                    $tmp[$i]['sortorder'] -= 1;
                    $tmp[$i - 1]['sortorder'] += 1;
                }
                break;
                case 'down':
                if ($i < ($rows - 1)) {
                    $tmp[$i]['sortorder'] += 1;
                    $tmp[$i + 1]['sortorder'] -= 1;
                }
                break;
            }

        }
    }

    // Update menu table

    foreach ($tmp as $record) {

        if (! set_field("cmsnavi_data", "sortorder", $record['sortorder'], "pageid", $record['id'])) {
            return false;
        }

    }
    return true;
}
?>