<?php // $Id$
// update selected page

    require_once("../config.php");
    include_once('cmslocallib.php');

    //optional_variable($id);

    $id   = required_param('id', PARAM_INT); // Menu id
    $skey = required_param('sesskey', PARAM_ALPHANUM);
    $courseid = optional_param('course', 0, PARAM_INT);

    if (! confirm_sesskey($skey)) {
        error("Session key error!");
    }

    /// Set up the overall site name etc.
    if (! $site = get_site()) {
        redirect("site.php");
    }

    if ( empty($courseid) ) {
        $courseid = $site->id;
    }

    if ( !$course = get_record("course", "id", $courseid) ) {
        error("Invalid course id!!!");
    }

    require_login();

    if ( !confirm_sesskey($skey) ) {
        error("Session key error!!!");
    }

    $isadmin = isadmin();
    $isteacheredit = isteacheredit($course->id);

    if ( !$isadmin && !$isteacheredit ) {
        error("You need to be an admin user to use this page.", "$CFG->wwwroot/");
    }

    if ( $page = data_submitted() ) {

        // Update title to cmsnavi_data
        $page->id     = clean_param($page->nid,    PARAM_INT);
        $page->naviid = clean_param($page->naviid, PARAM_INT);

        $page->title = stripslashes(strip_tags($page->title));

        if ( !empty($page->title) and preg_match("/^\S{3,}/", $page->title) ) {

            $page->parentid = !empty($page->parentid) ? intval($page->parentid) : 0;
            // If menu has been changed set parentid to zero.
            // And get all pages underneath this page and move them too
            // into that new menu.
            $oldnaviid = get_field("cmsnavi_data", "naviid", "id", $page->id);
            if ( intval($oldnaviid) !== intval($page->naviid) ) {
                $children = cms_get_children_ids($page->pageid);

                foreach ( $children as $childid ) {
                    if ( !set_field("cmsnavi_data", "naviid", $page->naviid,
                                    "pageid", $childid) ) {
                        error("Cannot modify menu information for child pages!",
                              "$CFG->wwwroot/cms/pages.php?course=$course->id".
                              "&amp;menuid=$oldnaviid");
                    }
                }

                $page->parentid = 0;
                $page->sortorder = 2000;
            }

            $page->title = addslashes($page->title);

            if (!update_record("cmsnavi_data", $page)) {
                error ("Error while linking page to menu! Page has been removed.");
            }

            // update page first
            $page->id       = clean_param($page->pageid, PARAM_INT);
            $page->modified = time();

            if (! empty($page->publish) ) {
                $page->publish = 1;
            } else {
                $page->publish = 0;
            }

            $page->body = strip_tags($page->body, $ALLOWED_TAGS);
            $page->body = addslashes($page->body);

            if (!update_record("cmspages", $page)) {
                error("Couldn't update page: $page->title!");
            }

            $message = get_string("pageupdated","cms", $page->title);
            redirect("pages.php?course=$course->id&amp;menuid=$page->naviid&amp;sesskey=$USER->sesskey", $message, 2);

        } else {
            $error = get_string('missingtitle','cms');
        }

    }

    $usehtmleditor = can_use_html_editor();

    $stradministration = get_string("administration");
    $strcms            = get_string("cms","cms");
    $strpages          = get_string("pages","cms");
    $strupdatepage     = get_string("updatepage","cms");
    $strformtitle      = &$strupdatepage;

    if ($course->category) {
        $navigation = "<a href=\"../course/view.php?id=$course->id\">$course->shortname</a> -> ";
    } else {
        $navigation = '';
    }

    $navigation .= '<a href="./index.php?course='. $course->id .'&amp;sesskey='. $USER->sesskey .'">'.
                   $strcms .'</a> -> <a href="pages.php?course='. $course->id .'&amp;sesskey='.
                   $USER->sesskey. '">'. $strpages .'</a> -> ';

    $form = empty($page) ? cms_get_pagedata($id) : cms_get_pagedata(intval($page->pageid));
    $form->menus = get_records("cmsnavi", "course", $course->id);
    $form->id = $form->naviid;
    $form->pageid = empty($page) ? $id : intval($page->pageid);

    ob_start();

    print_header("$site->shortname: $stradministration","$site->fullname", "$navigation $strupdatepage");
    print_simple_box_start("center", "100%", "", 20);
    print_heading($stradministration);

    if ( !empty($error) ) {

        if ( !empty($page) ) {
            $form->body  = $page->body;
        }

        notify($error);

    }

    include_once('html/editpage.php');

    print_simple_box_end();

    if ($usehtmleditor) {
        use_html_editor();
    }

    print_footer($course);

    ob_end_flush();

?>